// This may look like C code, but it is really -*- C++ -*-
/*
    newtonsc NewtonScript compiler
    Copyright (C) 1995  Ross Sponholtz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



*/
#ifndef EVALUE_H_INC
#define EVALUE_H_INC

class Evalue;

#include <iostream.h>
enum EValueType {EVString,EVInt,EVChar,EVReal,EVUlong,EVNone};
class EValue
{
public:
  enum EValueType theType;
  String strValue;
  int intValue;
  int charValue;
  double realValue;
  unsigned long ulValue;


  EValue():theType(EVNone){}
  EValue(unsigned long ul)
    {ulValue = ul; theType = EVUlong;}
  EValue(String str)
    {strValue = str; theType = EVString;}
  EValue(double dd)
    {realValue = dd; theType = EVReal;}
  EValue(int ii)
    {intValue = ii; theType = EVInt;}
  void operator = (const int ii)
    {intValue = ii; theType = EVInt;}
  void operator = (const String str)
    {strValue = str; theType = EVString;}
  void operator = (const double dd)
    {realValue = dd; theType = EVReal;}

  int isInt() {return (theType == EVInt);}
  EValueType GetType() {return theType;}
  int getIntValue() {return intValue;}
  String getStringValue() {return strValue;}
  void operator = (const EValue r);
  dump();

  EValue operator+(const EValue r) const;
  EValue operator-(const EValue r) const;
  EValue operator*(const EValue r) const;
  EValue operator/(const EValue r) const;
  EValue div(const EValue r) const;
  EValue mod(const EValue r) const;
  EValue lshft(const EValue r) const;
  EValue rshft(const EValue r) const;
  EValue band(const EValue r) const;
  EValue bor(const EValue r) const;
  EValue uminus() const;
  EValue not() const;
};

#endif
