#include "newtobjs.h"
#include "codebloc.h"
/*
    newtonsc NewtonScript compiler
    Copyright (C) 1995  Ross Sponholtz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



*/
AllObjects allObjects;

AllObjects::dump()
{
  NO_ObjectList tempList = theObjectList;
  NO_Object *tempObject;
  int i = 0;

  if (object_debug)
    {
      cout << "----------------all objects -----------" << endl;
      while (!tempList.empty())
	{
	  tempObject = tempList.remove_front();
	  tempObject->dump(2);
	}
    }
}


void NO_Object::outtab(int c)
{
  int i;
  
  cout << endl;
  cout.form("NO:%3.3d",c);
  for (i=0;i<c;++i)
    cout << " ";
}




NO_VpumPtr *NO_Object::CreateVPointer()
{
  NO_VpumPtr *nn;
  nn = new NO_VpumPtr(this);
  return nn;
}


virtual int NO_Array::dump(int tl)
{
  NO_ObjectList tempList = theElements;
  NO_Object *tempObject;
  int i = 0;
  
  outtab(tl);
  cout << "Array:" << theType ;
  
  while (!tempList.empty())
    {
      outtab(tl);
      cout << "------element:"<< i << "--------";
      ++i;
      tempObject = tempList.remove_front();
      tempObject->dump(tl+4);
    }
}

NO_Array::dumpElement(int eno,int tl)
{
  NO_ObjectList tempList = theElements;
  NO_Object *tempObject;
  int i = 0;
  
  for (i=0;i<=eno;++i)
    tempObject = tempList.remove_front();	
  tempObject->dump(tl);
}

unsigned long NO_Array::getElementHash(int eno)
{
  NO_ObjectList tempList = theElements;
  NO_Object *tempObject;
  int i = 0;
  
  for (i=0;i<=eno;++i)
    tempObject = tempList.remove_front();	
  return tempObject->getHash();
}


NO_Frame::AddSlot(NO_Symbol *s,NO_Object *ob)
{
  frameMap->AddElement(s);
  theSlots.append(ob);
}

#define HASH_instructions       0x83a63acd

virtual int NO_Frame::dump(int tl)
{
  NO_ObjectList tempList = theSlots;
  NO_Object *tempObject;
  int i = 0;
  unsigned int temphash;
  NO_Data *nd;
  
  outtab(tl);
  cout << "Frame:";
  frameMap->dump(tl + 4);
  outtab(tl+2);
  cout << "Slots:";
  while (!tempList.empty())
    {
      outtab(tl);
      cout << "------slot:"<< i << "--------";
      frameMap->dumpElement(i,tl+4);
      ++i;
      tempObject = tempList.remove_front();
      tempObject->dump(tl+4);
    }
}

extern int show_instructions(BYTE *ip, int cnt);

virtual int NO_Data::dump(int tl)
{
  int i,cnt,tmp;
  const char *rep;
  outtab(tl);
  rep = (const char *)theString;


  if (isCode)
    {
      show_instructions((BYTE *)rep,theString.length());
    }
  else
    {
      cout << "Data:";
      for (i=0;i<theString.length();++i)
	{
	  tmp = rep[i] & 0xFF;
	  cout.form("0x%02x ",tmp);
	}
    }
}






