/*
    newtonsc NewtonScript compiler
    Copyright (C) 1995  Ross Sponholtz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



*/
typedef unsigned char   uchar;      /* 1 byte */
typedef unsigned short  unichar;    /* 2 bytes (Unicode character) */
#ifdef USHORT
typedef unsigned short  ushort;     /* 2 bytes */
typedef unsigned long   ulong;      /* 4 bytes */
#endif

#define LBYTE1(bb) (((bb) >> 24)& 0xFF )
#define LBYTE2(bb) (((bb) >> 16)& 0xFF )
#define LBYTE3(bb) (((bb) >> 8)& 0xFF )
#define LBYTE4(bb) ((bb)& 0xFF )

#define SBYTE1(bb) (((bb) >> 8)& 0xFF )
#define SBYTE2(bb) ((bb)& 0xFF )


class  PartHdr;
class  VarStrings;
class  PkgRecordList;


class Package
{
  ulong packageFlags;
  ulong versionNo;
  ulong   packageLength;
  ulong   createdTimeStamp;
  ulong   modifiedTimeStamp;
  ulong   firstRecordOffset;
  ulong   partCount;

  String authorCopyright;
  String packageName;

  String NTKcopyright;

  PartHdr thePart;
  VarStrings theStrings;
  PkgRecordList theRecords;


  String recordRep;
public:

  public:
  makeRep()
    {
      int  authorCopyrightLength;
      int packageNameLength;


      authorCopyrightLength = authorCopyright.length();
      packageNameLength = packageName.length();

      recordRep = "";
      recordRep += "package0";
      recordRep += "xxxx";

      recordRep += LBYTE1(packageFlags);
      recordRep += LBYTE2(packageFlags);
      recordRep += LBYTE3(packageFlags);
      recordRep += LBYTE4(packageFlags);

      recordRep += LBYTE1(versionNo);
      recordRep += LBYTE2(versionNo);
      recordRep += LBYTE3(versionNo);
      recordRep += LBYTE4(versionNo);
      recordRep += '\0';
      recordRep += '\0';

      recordRep += SBYTE1(authorCopyrightLength);
      recordRep += SBYTE2(authorCopyrightLength);
      recordRep += SBYTE1(authorCopyrightLength);
      recordRep += SBYTE2(authorCopyrightLength);
      recordRep += SBYTE1(packageNameLength);
      recordRep += SBYTE2(packageNameLength);

      recordRep += SBYTE1(packageLength);
      recordRep += SBYTE2(packageLength);
      recordRep += SBYTE3(packageLength);
      recordRep += SBYTE4(packageLength);

      recordRep += SBYTE1(createdTimeStamp);
      recordRep += SBYTE2(createdTimeStamp);
      recordRep += SBYTE3(createdTimeStamp);
      recordRep += SBYTE4(createdTimeStamp);

      recordRep += SBYTE1(modifiedTimeStamp);
      recordRep += SBYTE2(modifiedTimeStamp);
      recordRep += SBYTE3(modifiedTimeStamp);
      recordRep += SBYTE4(modifiedTimeStamp);

      recordRep += '\0';
      recordRep += '\0';
      recordRep += '\0';
      recordRep += '\0';

      recordRep += SBYTE1(firstRecordOffset);
      recordRep += SBYTE2(firstRecordOffset);
      recordRep += SBYTE3(firstRecordOffset);
      recordRep += SBYTE4(firstRecordOffset);

      recordRep += SBYTE1(partCount);
      recordRep += SBYTE2(partCount);
      recordRep += SBYTE3(partCount);
      recordRep += SBYTE4(partCount);
    }
};


class PartHdr
{
  String partString;

  ulong partOffset;
  ulong lengthOfData;
  String partType;
  int partStringOffset;


  String recordRep;

public:
  makeRep(Package *pk)
    {
      int partStringLength;

      partStringLength = partString.length();

      recordRep = "";
      
      recordRep += LBYTE1(partOffset);
      recordRep += LBYTE2(partOffset);
      recordRep += LBYTE3(partOffset);
      recordRep += LBYTE4(partOffset);

      recordRep += LBYTE1(lengthOfData);
      recordRep += LBYTE2(lengthOfData);
      recordRep += LBYTE3(lengthOfData);
      recordRep += LBYTE4(lengthOfData);

      recordRep += partType[0];
      recordRep += partType[1];
      recordRep += partType[2];
      recordRep += partType[3];
      recordRep += '\0';
      recordRep += '\0';
      recordRep += '\0';
      recordRep += '\0';

      recordRep += '\0';
      recordRep += '\0';
      recordRep += '\0';
      recordRep += 0x81;
      
      recordRep += SBYTE1(partStringOffset);
      recordRep += SBYTE2(partStringOffset);
      recordRep += SBYTE1(partStringLength);
      recordRep += SBYTE2(partStringLength);
      recordRep += '\0';
      recordRep += '\0';
      recordRep += '\0';
      recordRep += '\0';
    }
};

class VarStrings
{

  String recordRep;
public:
  MakeRep(Package *pk,Part *pt)
    {
      recordRep = "";
      for (int i=0;i<pk->authorCopyright.length();++i)
	  recordRep += pk->authorCopyright[i];
      recordRep += '\0';
      recordRep += '\0';
      for (int i=0;i<pk->packageName.length();++i)
	  recordRep += pk->packageName[i];
      recordRep += '\0';
      recordRep += '\0';
      for (int i=0;i<pt->partString.length();++i)
	  recordRep += pt->partString[i];
      for (int i=0;i<pk->NTKcopyright.length();++i)
	  recordRep += pk->NTKcopyright[i];
      // padwithbytes(0xff,4);
    }
};

class PkgRecord;

enum VpumType{VpumValue,VpumPointer,VpumUnusual,VpumMagic};
class Vpum
{
  int value;
  enum VpumType theType;
  PkgRecord *theRef;
  int hasRef;

public:
  Vpum(int nv,enum VpumType tt):value(nv),theType(tt) 
    {hasRef = 0;}

  Vpum(pkgRecord *ref)
    {
      theRef = ref;
      hasRef = 1;
    };
  ulong Rep()
    {
      //TODO fill this in here
    }
};

typedef DLList<Vpum *> VpumList;

#define VPUM_SYMBOL_CLASS Vpum((5555<<2) + 2,VpumUnusual)

#define PF_RECORD_TYPE_DATA     0x40
#define PF_RECORD_TYPE_ARRAY    0x41
#define PF_RECORD_TYPE_FRAME    0x43

class  PkgRecord
{
  int recordLength;
  int recordType;
  int recordFlags;
  Vpum recordClass;
  int recordOffset;



public:
#ifdef INCL_REP
    /* Note that only 3 bytes are used to hold the length of the record.
     */
    uchar   recordLength[3];

    /* This byte indicates what the record represents, one of raw data, a
     * NewtonScript array or a NewtonScript frame.  The three values used
     * are given above.
     */
    uchar   recordType;

    /* These flags are always zero in the package file, though I believe
     * that the in-memory representation of this data is similar to the
     * in-file representation and when in-memory this flags field is used.
     */
    ulong   recordFlags;

    /* This gives more detailed information about the record.  The exact
     * meaning of the field depends on the recordType.  See below.
     */
    Vpum    recordClass;
    
    /*      data follows here if record has data... see below.
     */
#endif
};

typedef DLList<PkgRecord *> PkgRecordList;

class  DataRecord : public PkgRecord
{
  String recordData;

  String recordRep;
#ifdef INCL_REP
#endif
public:
  makeRep()
    {
      ulong tr = Rep(recordClass);

      recordRep = "";
      recordRep += LBYTE2(recordLength);
      recordRep += LBYTE3(recordLength);
      recordRep += LBYTE4(recordLength);
      recordRep += recordType;

      recordRep += LBYTE1(recordFlags);
      recordRep += LBYTE2(recordFlags);
      recordRep += LBYTE3(recordFlags);
      recordRep += LBYTE4(recordFlags);

      recordRep += LBYTE4(tr);
      recordRep += LBYTE4(tr);
      recordRep += LBYTE4(tr);
      recordRep += LBYTE4(tr);
      
      recordRep += recordData;
    }
};

class SymbolRecord : public PkgRecord
{
  ulong symbolHashValue;
  String symbolName;

public:
  SymbolRecord(String newName)
    {
      symbolName = newName;
      recordType = PF_RECORD_TYPE_DATA;
      recordFlags = 0;
      recordClass = VPUM_SYMBOL_CLASS     
    }

  ComputeHash()
    {
      ulong temph = 0;
      String ts = upcase(symbolName);
      for (int i=0;i<ts.length();++i)
	{
	  temph += ts[i];
	}
      temph = temph * 0x9e3779b9;
      symbolHashValue = temph;
    }
#ifdef INCL_REP
    uchar   recordLength[3];
    uchar   recordType;         /* 0x40 */
    ulong   recordFlags;        /* 0 */
    vpum    recordClass;        /* VPUM_SYMBOL_CLASS */
    ulong   symbolHashValue;
    uchar   symbolName[1];
#endif
};


class ArrayRecord : public PkgRecord
{
  VpumList theElements;
public:
#ifdef INCL_REP
    uchar   recordLength[3];
    uchar   recordType;         /* 0x41 */
    ulong   recordFlags;        /* 0 */
    vpum    recordClass;
    vpum    arrayElement[1];
#endif
};


class FrameMap : public PkgRecord
{


  Vpum nextMap;
  VpumList theSlots;
  
#ifdef INCL_REP
    uchar   recordLength[3];
    uchar   recordType;         /* 0x41 */
    ulong   recordFlags;        /* 0 */
    vpum    recordClass;        /* Combination of PF_FM_... above */
    vpum    nextMap;            /* Offset of next map or VPUM_NIL */
    vpum    frameSlotName[1];   /* Offset of slot name symbol record */
#endif
};



class FrameRecord : public PkgRecord
{
  FrameMap slotMap;
  VpumList theValues;

public:
  
#ifdef INCL_REP
    uchar   recordLength[3];
    uchar   recordType;         /* 0x43 */
    ulong   recordFlags;        /* 0 */
    vpum    recordClass;        /* Always an offset to a frame map */
    vpum    frameSlotValue[1];
#endif
  
};




